package lancs.midp.ptolemy.exceptionblocks.utilAspectEH.handler;

import java.io.IOException;

import lancs.midp.mobilephoto.lib.exceptions.ImagePathNotValidException;
import lancs.midp.mobilephoto.lib.exceptions.InvalidArrayFormatException;
import lancs.midp.mobilephoto.lib.exceptions.InvalidImageDataException;
import lancs.midp.mobilephoto.lib.exceptions.InvalidImageFormatException;
import ubc.midp.mobilephoto.core.ui.datamodel.ImageData;
import lancs.midp.ptolemy.exceptionblocks.utilAspectEH.events.*;
import edu.iastate.cs.ptolemy.runtime.*;

@Instantiation(Instantiation.Model.SINGLETON)
@Registration(Registration.Model.IMPLICIT)
public class utilEventHandler {
	public utilEventHandler() { register(this); }
	
	public void handler(ReadInternalImageAsByteArrayEvent next) throws Throwable {
		try {
			invoke(next);
		} catch (IOException e) {
			throw new InvalidImageFormatException("The file " + next.imageFile + " does not have PNG format");
		} catch (NullPointerException e) {
			throw new ImagePathNotValidException("Path not valid for this image:" + next.imageFile);
		}
	}
	
	when ReadInternalImageAsByteArrayEvent do handler;
	
	public void handler(ReadImageAsByteArrayEvent next) throws Throwable {
		try {
			invoke(next);
		} catch (Exception e) {
			throw new ImagePathNotValidException("Path not valid for this image:" + next.imageFile);
		}
	}
	
	when ReadImageAsByteArrayEvent do handler;
	
	public ImageData handler(GetImageInfoFromBytesEvent next) throws Throwable {
		try {
			return invoke(next);
		} catch (Exception e) {
			throw new InvalidArrayFormatException();
		}
	}
	
	when GetImageInfoFromBytesEvent do handler;
	
	public void handler(GetBytesFromImageInfoEvent next) throws Throwable {
		try {
			invoke(next);
		} catch (Exception e) {
			throw new InvalidImageDataException("The provided data are not valid");
		}
	}
	
	when GetBytesFromImageInfoEvent do handler;
}
